//
//  CaptureViewController.h
//  EBotViewerForOSX
//
//  Created by CHIKYEOM on 1/11/14.
//  Copyright (c) 2014 Development. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AVFoundation/AVFoundation.h>
#import "CKCaptureView.h"

@interface CKCaptureViewController : NSViewController

@property (strong, readonly) AVCaptureSession *session;
@property (strong, readonly) AVCaptureDevice *selectedVideoDevice;
@property (strong, readonly) AVCaptureDevice *selectedAudioDevice;
@property (strong, readonly) AVCaptureDeviceFormat *videoDeviceFormat;
@property (strong, readonly) AVCaptureDeviceFormat *audioDeviceFormat;

@property (strong) IBOutlet CKCaptureView *captureView;

@property (copy) void (^eventSetupVideoPreview)(AVCaptureVideoPreviewLayer* videoPreviewLayer);


- (id)initWithDefaultDevice;
- (id)initWithVideoDeviceID:(NSString*)videoDeviceID andAudioDeviceID:(NSString*)audioDeviceID;
- (id)initWithLocalizedVideoDeviceName:(NSString*)videoDeviceName andAudioDeviceName:(NSString*)audioDeviceName;


@end
