//
//  CKTreeMenuController.h
//  CKTreeMenu
//
//  Created by CHIKYEOM on 11/1/14.
//  Copyright (c) 2013 Development. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CKTreeMenuItem.h"


@interface CKTreeMenuController : NSViewController<NSTableViewDelegate, NSTableViewDataSource>


@property (strong, nonatomic) CKTreeMenu* menu;
@property (assign, nonatomic) float scale;
@property (assign, nonatomic) BOOL closeOnBackspaceKey;
@property (weak, nonatomic, readonly) NSResponder* firstResponder;
@property (strong, nonatomic) NSColor* backgroundColor;
@property (strong, nonatomic) NSColor* cellBackgroundColor;
@property (strong, nonatomic) NSColor* cellDisabledColor;
@property (strong, nonatomic) NSColor* cellDisabledTextColor;
@property (strong, nonatomic) NSColor* cellTextColor;
@property (strong, nonatomic) NSColor* cellHilightColor;
@property (strong, nonatomic) NSColor* cellHilightTextColor;
@property (strong, nonatomic) NSColor* cellBorderColor;
@property (strong, nonatomic) NSColor* sliderBackgroundColorInNormalMode;
@property (strong, nonatomic) NSColor* sliderBackgroundColorInEditMode;
@property (strong, nonatomic) NSColor* sliderBorderColorInNormalMode;
@property (strong, nonatomic) NSColor* sliderBorderColorInEditMode;
@property (weak, nonatomic) CKTreeMenuItem* selectedMenuItem;


@property (copy, nonatomic) void(^eventClosed)();

- (id)init;
- (void)updateLayout;
- (void)updateUIState;
- (void)reload;
- (void)close:(id)sender;

@end
