//
//  CKTreeMenuItem.h
//  CKTreeMenu
//
//  Created by CHIKYEOM on 11/1/14.
//  Copyright (c) 2013 Development. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NSMutableArray CKTreeMenu;






typedef enum eCKTreeMenuItemType {
    TMT_LABEL,
    TMT_TEXTEDIT,
    TMT_HOTKEY,
    TMT_CHECKBOX,
    TMT_SLIDER,
    TMT_RADIO_GROUP,
} eCKTreeMenuItemType;




typedef enum eCKTreeMenuItemEditState {
    TMES_NORMAL,
    TMES_EDIT,    
}eCKTreeMenuItemEditState;







@interface CKTreeMenuItem : NSObject

@property (assign, nonatomic, readonly) eCKTreeMenuItemType type;
@property (strong, nonatomic) NSString* labelText;
@property (strong, nonatomic) CKTreeMenu* subMenu;
@property (weak, nonatomic) CKTreeMenu* ownerMenu;
@property (assign, nonatomic) BOOL expanded;
@property (assign, nonatomic) BOOL selected;
@property (assign, nonatomic) BOOL disabled;
@property (strong, nonatomic) id userData;
@property (assign, nonatomic) BOOL clickOnExit;
@property (strong, nonatomic) id valueForRollback;
@property (assign, nonatomic) BOOL enableRollback;
@property (assign, nonatomic) eCKTreeMenuItemEditState editState;

@property (copy, nonatomic) void(^eventItemSelected)(id sender);
@property (copy, nonatomic) void(^eventItemClicked)(id sender);
@property (copy, nonatomic) void(^eventValueChanged)(id sender, id value);
@property (copy, nonatomic) void(^eventMenuExpanded)(id sender);
@property (copy, nonatomic) void(^eventMenuCollapsed)(id sender);
@property (copy, nonatomic) void(^eventBeginEdit)(id sender);
@property (copy, nonatomic) void(^eventEndEdit)(id sender);
@property (copy, nonatomic) void(^eventCancelEdit)(id sender, id value);

@end







@interface CKTreeMenuItemTextEdit : CKTreeMenuItem

@property (strong, nonatomic) NSString* valueOfTextEdit;

@end





@interface CKTreeMenuItemHotKey : CKTreeMenuItem

@property (strong, nonatomic) NSString* valueOfHotKey;

@end







@interface CKTreeMenuItemCheckBox : CKTreeMenuItem

@property (assign, nonatomic) BOOL valueOfCheckBox;

@end




@interface CKTreeMenuItemRadioGroup : CKTreeMenuItem

@property (assign, nonatomic) BOOL valueOfRadioGroup;
@property (assign, nonatomic) BOOL enableToggle;

- (void)exclusiveSelect;
- (void)deselectAll;

@end






@interface CKTreeMenuItemSlider : CKTreeMenuItem

@property (assign, nonatomic) int valueOfSlider;
@property (assign, nonatomic) int minValue;
@property (assign, nonatomic) int maxValue;

@end


