//
//  CKPacketAssembler.h
//  EBotViewerForOSX
//
//  Created by CHIKYEOM on 2/4/14.
//  Copyright (c) 2014 Development. All rights reserved.
//

#ifndef __EBotViewerForOSX__CKPacketAssembler__
#define __EBotViewerForOSX__CKPacketAssembler__

#include <functional>


class CKPacketAssembler
{
    uint8_t* _headerData;
    uint8_t* _bodyData;
    uint32_t _sizeOfHeader;
    uint32_t _sizeOfHeaderFilled;
    uint32_t _sizeOfBody;
    uint32_t _sizeOfBodyFilled;
    
public:
    CKPacketAssembler(uint32_t headerSize);
    virtual ~CKPacketAssembler();
    
public:
    std::function<void(void* headerData, int headerSize, void* bodyData, int bodySize)> eventDataAvailable;
    std::function<uint32_t(void* headerData, int headerSize)> delegateGetBodySizeFromHeaderData;
    std::function<uint32_t()> delegateGetBodyDataOffset;
    
public:
    void Assemble(void* data, int size);
    
private:
    uint32_t GetBodySizeFromHeaderData(void* headerData, int headerSize);
    uint32_t FillHeader(void* data, uint32_t size);
    uint32_t FillBody(void* data, uint32_t size);
};


#endif /* defined(__EBotViewerForOSX__CKPacketAssembler__) */
