//
//  USBDevice.h
//  EBotViewerForOSX
//
//  Created by CHIKYEOM on 1/15/14.
//  Copyright (c) 2014 Development. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/usb/IOUSBLib.h>
#import <IOKit/usb/USBSpec.h>
#import <IOKit/IOCFPlugIn.h>

@class USBInterface;

@interface USBDevice : NSObject

@property (strong, nonatomic, readonly) NSString* productName;
@property (strong, nonatomic, readonly) NSString* manufacturer;
@property (strong, nonatomic, readonly) NSString* serialNumber;
@property (assign, nonatomic, readonly) UInt8 deviceClass;
@property (assign, nonatomic, readonly) UInt8 deviceSubClass;
@property (assign, nonatomic, readonly) UInt8 deviceProtocol;
@property (assign, nonatomic, readonly) UInt16 deviceVendor;
@property (assign, nonatomic, readonly) UInt16 deviceProduct;
@property (assign, nonatomic, readonly) UInt16 deviceReleaseNumber;
@property (assign, nonatomic, readonly) USBDeviceAddress deviceAddress;
@property (assign, nonatomic, readonly) UInt32 deviceBusPowerAvailable;
@property (assign, nonatomic, readonly) UInt8 deviceSpeed;
@property (assign, nonatomic, readonly) UInt8 numberOfConfigurations;
@property (assign, nonatomic, readonly) UInt32 locationID;


+ (NSArray*)devices;

- (NSArray*)interfaces;
- (IOReturn)deviceOpen;
- (IOReturn)deviceClose;
- (IOUSBConfigurationDescriptorPtr)getConfigurationDescriptorPtrAtIndex:(UInt8)configIndex;
- (void)setConfiguration:(UInt8)configNum;
- (UInt8)getConfiguration;
- (IOReturn)deviceRequest:(IOUSBDevRequest*)request;
- (void)getBusFrameNumber:(UInt64*)frame atTime:(AbsoluteTime*)atTime;
- (IOReturn)resetDevice;

@end
