//
//  USBEndPoint.h
//  EBotViewerForOSX
//
//  Created by CHIKYEOM on 1/23/14.
//  Copyright (c) 2014 Development. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/usb/IOUSBLib.h>
#import <IOKit/usb/USBSpec.h>
#import <IOKit/IOCFPlugIn.h>


@interface USBEndPoint : NSObject

@property (assign, nonatomic, readonly) UInt8 pipeNumber;
@property (assign, nonatomic, readonly) UInt8 direction;
@property (assign, nonatomic, readonly) UInt8 number;
@property (assign, nonatomic, readonly) UInt8 transferType;
@property (assign, nonatomic, readonly) UInt16 maxPacketSize;
@property (assign, nonatomic, readonly) UInt8 interval;

- (id)initWithInteface:(IOUSBInterfaceInterface182**)interface andPipeNumber:(UInt8)pipe;
- (IOReturn)controlRequest:(IOUSBDevRequest*)req;
- (IOReturn)controlRequestTo:(IOUSBDevRequestTO*)req;
- (IOReturn)getPipeStatus;
- (void)abortPipe;
- (void)resetPipe;
- (void)clearPipeStall;
- (IOReturn)readPipeWithBuffer:(void*)buf size:(UInt32*)size;
- (IOReturn)writePipeWithBuffer:(void*)buf size:(UInt32)size;

@end
