//
//  USBInterface.h
//  EBotViewerForOSX
//
//  Created by CHIKYEOM on 1/15/14.
//  Copyright (c) 2014 Development. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/usb/IOUSBLib.h>
#import <IOKit/usb/USBSpec.h>
#import <IOKit/IOCFPlugIn.h>

@class USBDevice;
@class USBEndPoint;


@interface USBInterface : NSObject

@property (assign, nonatomic, readonly) UInt8 interfaceClass;
@property (assign, nonatomic, readonly) UInt8 interfaceSubClass;
@property (assign, nonatomic, readonly) UInt8 interfaceProtocol;
@property (assign, nonatomic, readonly) UInt16 deviceVendor;
@property (assign, nonatomic, readonly) UInt16 deviceProduct;
@property (assign, nonatomic, readonly) UInt16 deviceReleaseNumber;
@property (assign, nonatomic, readonly) UInt8 configurationValue;
@property (assign, nonatomic, readonly) UInt8 interfaceNumber;
@property (assign, nonatomic, readonly) UInt8 alternateSetting;
@property (assign, nonatomic, readonly) UInt8 numEndpoints;
@property (assign, nonatomic, readonly) UInt32 locationID;
@property (strong, nonatomic, readonly) USBEndPoint* defaultControlEndPoint;
@property (strong, nonatomic, readonly) USBDevice* device;


- (id)initWithDevice:(USBDevice*)device andInterface:(IOUSBInterfaceInterface182**)interface;
- (NSArray*)endPoints;
- (void)createInterfaceAsyncEventSource:(CFRunLoopSourceRef*)source;
- (CFRunLoopSourceRef)getInterfaceAsyncEventSource;
- (void)createInterfaceAsyncPort:(mach_port_t*)port;
- (mach_port_t)getInterfaceAsyncPort;
- (IOReturn)interfaceOpen;
- (IOReturn)interfaceClose;
- (void)setAlternateInterface:(UInt8)alternateSetting;
- (void)getBusFrameNumber:(UInt64*)frame atTime:(AbsoluteTime*)atTime;

@end
